/*
 * Copyright (c) 1996-7 Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *       This product includes software developed by the Computer Systems
 *       Engineering Group at Lawrence Berkeley Laboratory.
 * 4. Neither the name of the University nor of the Laboratory may be used
 *    to endorse or promote products derived from this software without
 *    specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * ---------------------------
 *
 * Filename: error.cc	-- Teck-Lee Tung Sat Nov  2 1996
 * Description: error reporting
 *
 * $Header: /usr/src/mash/repository/mash/mash-1/mb/error.cc,v 1.9 1997/11/26 22:33:17 tecklee Exp $
 */

#ifndef ERROR_CC
#define ERROR_CC
#include "mb.h"

#ifndef lint
static char *rcsid = "$Header: /usr/src/mash/repository/mash/mash-1/mb/error.cc,v 1.9 1997/11/26 22:33:17 tecklee Exp $";
#endif

#include <stdlib.h>
#include "error.h"
#include "tclcl.h"

char szErrorMsg[1024];

void disperr(const char* fmt, ...) 
{
	va_list ap=NULL;
	va_start(ap,fmt);
	vfprintf(stderr, fmt, ap);
}

int dispTclErr(const char* msg)
{
	fprintf(stderr, msg);
	fprintf(stderr, "\n");
	Tcl& tcl = Tcl::instance();
	fprintf(stderr,
		Tcl_GetVar(tcl.interp(), "errorInfo",
			   TCL_GLOBAL_ONLY));
	fprintf(stderr, "\n");
	return TCL_OK;
}

#endif /* #ifdef ERROR_CC */ 
