/*
 * Copyright (c) 1998 Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *       This product includes software developed by the Computer Systems
 *       Engineering Group at Lawrence Berkeley Laboratory.
 * 4. Neither the name of the University nor of the Laboratory may be used
 *    to endorse or promote products derived from this software without
 *    specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * ------------
 *
 * Filename: mbv2-listsort.h
 *   -- Created on Fri Nov 27 1998
 *   -- Author: Yatin Chawathe <yatin@cs.berkeley.edu>
 *
 * Description:
 *
 *
 *  @(#) $Header: /usr/src/mash/repository/mash/mash-1/mbv2/mbv2-listsort.h,v 1.1 1998/12/03 20:36:16 yatin Exp $
 */

#ifndef MASH_MBV2_LISTSORT_H
#define MASH_MBV2_LISTSORT_H


template <class T>
void
insert_sorted(List<T> *list, T *d)
{
	// add in increasing order of waitingForCmd
	if (list->IsEmpty()) {
		// add at the head of the list
		list->InsertAtHead(d);
	} else if (list->PeekAtTail()->compare(*d) <= 0) {
		// add at the tail of the list
		list->InsertAtTail(d);
	}
	else {
		// insert somewhere in the middle of the list
		ListIndex idx;
		for (idx=list->getFirst();
		     !list->IsDone(idx);
		     idx=list->getNext(idx))
		{
			if (list->getData(idx)->compare(*d) >= 0) {
				list->InsertBefore(idx, d);
				break;
			}
		}
	}
}


#endif /* #ifdef MASH_MBV2_LISTSORT_H */ 
