Class StockcastUI

StockcastUI public init { w app as } {
	$self instvar w_ app_ as_ totalnumsyms_ numsyms_
	set w_ $w
	set app_ $app
	set as_ $as
	set numsyms_ 0
	set totalnumsyms_ 0	

	$self tkvar show_stocks show_hls
	set show_stocks 1
	set show_hls 1

	# top menu bar
	frame $w_.mb -relief raised -bd 2
	pack $w_.mb -side top -fill x

	# options menu button
	menubutton $w_.mb.opt -text "Options" -menu $w_.mb.opt.m
	pack $w_.mb.opt -side left
	menu $w_.mb.opt.m -tearoff no
	$w_.mb.opt.m add command -label "Add symbol" -command "$self popup_add_symbol"
	$w_.mb.opt.m add command -label "Delete symbol" -command "$self popup_del_symbol"
	$w_.mb.opt.m add command -label "Change configuration" -command "$self popup_conf_symbol"
	# quit button
	menubutton $w_.mb.q -text Quit -menu $w_.mb.q.m
	pack $w_.mb.q -side right
	menu $w_.mb.q.m -tearoff no
	$w_.mb.q.m add command -label "Yes, really quit" -command "$self destroy"
	$w_.mb.q.m add command -label "No, don't quit"	

	focus $w_.mb

	# fixed title bar
	frame $w_.main 
	set l [frame $w_.main.fixed]

	label $l.sym -text "Symbol\n " -relief groove -width 10 -anchor w
	label $l.time -text "Date/\nTime" -relief groove -width 10 -anchor w
	label $l.last -text "Last Traded\n " -relief groove -width 10 -anchor w
	label $l.change -text "Change $/\nChange %" -relief groove -width 10 -anchor w
	label $l.volume -text "Volume\n " -relief groove -width 10 -anchor w
	label $l.trades -text "# of Trades\n " -relief groove -width 10 -anchor w
	label $l.openclose -text "Open/\nClose" -relief groove -width 10 -anchor w
	label $l.highlow -text "52 Wk High/\n52 Wk Low" -relief groove -width 10 -anchor w

	pack $l.sym $l.time $l.last $l.change $l.volume $l.trades $l.openclose $l.highlow \
		-side left
	pack $w_.main.fixed -anchor nw -pady 10

	# scrollable view for symbols
	set s [frame $w_.main.sl]
	set can $s.can
	set y $s.y
	canvas $can -width 8.1i -height 2.5i -scrollregion "0 0 8.1i 2.5i" \
			-takefocus 1 -yscrollcommand "$y set"
	scrollbar $y -orient vert -command "$can yview"
	frame $can.main
	$can create window 0 0 -anchor nw -window $can.main
	pack $y -side right -fill y
	pack $can -side left -expand true -fill both
	pack $s -expand t -fill both -side top

	# default symbols
	set ds "INTC FORE DELL CSCO MSFT"
	#set ds "AAPL ADBE ADCT ADPT ADSK"
	foreach s $ds {
		$self mkrow_symbol $s
	}

	set end [label $w_.main.end -relief raised]
	pack $end -expand t -fill x

	pack $w_.main
}

StockcastUI public destroy { } {
	exit
}

StockcastUI public change_symbols { } {
	$self instvar syms_ app_ as_
	global ssd

	foreach idx [array names syms_] {
		lappend all $syms_($idx)
	}
	set ssd(pref) $all
	$as_ set_agent_data [array get ssd]

	$app_ regroup
}

StockcastUI private popup_add_symbol { } {
	# dialog box
	$self instvar addui_

	if [info exists addui_] {
		wm deiconify $addui_
		return
	}

	global newsym	

	toplevel .add
	set w .add
	wm title $w "Add symbol"

	frame $w.enter
	message $w.enter.inst -text "Enter symbol(s) you want to add to the user interface, separated by commas" -aspect 1000
	entry $w.enter.entry -textvariable newsym -relief sunken -width 30
	pack $w.enter.inst
	pack $w.enter.entry -expand true -fill x

	frame $w.buttons
	button $w.buttons.ok -text OK -command "wm withdraw $w; $self mkrow_symbols"
	button $w.buttons.cancel -text Cancel -command "wm withdraw $w"
	button $w.buttons.clear -text Clear -command "set newsym {}"
	pack $w.buttons.ok $w.buttons.cancel $w.buttons.clear \
		-side left -fill x -expand true -padx 5

	pack $w.enter $w.buttons -pady 5 -padx 5

	set addui_ $w
}

StockcastUI private popup_del_symbol { } {
	# dialog box
	$self instvar delui_

	if [info exists delui_] {
		wm deiconify $delui_
		return
	}
	
	global delsym

	toplevel .del
	set w .del
	wm title $w "Delete symbol"

	frame $w.enter
	message $w.enter.inst -text "Enter symbol(s) you want to delete from the user interface, separated by commas" -aspect 1000
	entry $w.enter.entry -textvariable delsym -relief sunken -width 30
	pack $w.enter.inst
	pack $w.enter.entry -expand true -fill x

	frame $w.buttons
	button $w.buttons.ok -text OK -command "wm withdraw $w; $self delrow_symbols"
	button $w.buttons.cancel -text Cancel -command "wm withdraw $w"
	button $w.buttons.clear -text Clear -command "set delsym {}"
	pack $w.buttons.ok $w.buttons.cancel $w.buttons.clear \
		-side left -fill x -expand true -padx 5

	pack $w.enter $w.buttons -pady 5 -padx 5

	set delui_ $w
}

StockcastUI private popup_conf_symbol { } {
	# dialog box
	$self instvar confui_

	if [info exists confui_] {
		wm deiconify $confui_
		return
	}

	global confsym confval conft confd confp confv
	set confval time

	toplevel .conf
	set w .conf
	wm title $w "Configure symbol"

	frame $w.sym
	message $w.sym.inst -text "Enter symbol(s) you want to configure, separated by commas:" -aspect 1000
	entry $w.sym.entry -textvariable confsym -relief sunken -width 30
	pack $w.sym.inst
	pack $w.sym.entry -expand true -fill x

	frame $w.conf
	
	frame $w.conf.t
	radiobutton $w.conf.t.time -text "Periodic (in secs):" -variable confval -value time
	entry $w.conf.t.entry -textvariable conft -relief sunken
	pack $w.conf.t.time -side left -padx 5 -anchor nw
	pack $w.conf.t.entry -side left -fill x -expand true -anchor nw
	pack $w.conf.t -fill x
	
	frame $w.conf.d
	radiobutton $w.conf.d.dchg -text "$ Change by:" -variable confval -value dollar
	entry $w.conf.d.entry -textvariable confd -relief sunken
	pack $w.conf.d.dchg -side left -padx 5 -anchor nw
	pack $w.conf.d.entry -side left -fill x -expand true -anchor nw
	pack $w.conf.d -fill x	
	
	frame $w.conf.p	
	radiobutton $w.conf.p.pchg -text "% Change by:" -variable confval -value percent
	entry $w.conf.p.entry -textvariable confp -relief sunken
	pack $w.conf.p.pchg -side left -padx 5 -anchor nw
	pack $w.conf.p.entry -side left -fill x -expand true -anchor nw
	pack $w.conf.p -fill x	
	
	frame $w.conf.v	
	radiobutton $w.conf.v.vchg -text "Volume Change by:" -variable confval -value vol
	entry $w.conf.v.entry -textvariable confv -relief sunken
	pack $w.conf.v.vchg -side left -padx 5 -anchor nw
	pack $w.conf.v.entry -side left -fill x -expand true -anchor nw
	pack $w.conf.v -fill x	

	frame $w.buttons
	button $w.buttons.ok -text OK -command "wm withdraw $w; $self conf_symbols"
	button $w.buttons.cancel -text Cancel -command "wm withdraw $w"
	button $w.buttons.clear -text Clear -command "set confsym {}; set confval time; set conft {}; set confd {}; set confp {}; set confv {}"
	pack $w.buttons.ok $w.buttons.cancel $w.buttons.clear \
		-side left -fill x -expand true -padx 5

	pack $w.sym $w.conf $w.buttons -pady 5 -padx 5

	set confui_ $w
	
}

StockcastUI public is_interest { sym } {
	$self instvar syms_

	foreach idx [array names syms_] {
		if { "$syms_($idx)" == "$sym" } {
			return 1
		}
	}
	return 0
}

StockcastUI public get_interest { } {
	$self instvar syms_

	foreach idx [array names syms_] {
		lappend all $syms_($idx)
	}
	return $all
}

StockcastUI public get_pref { sym } {
	$self instvar syms_ confs_
	
	if { [$self is_interest $sym] == 1 } {
		if [info exists confs_($sym)] {
			return $confs_($sym)
		} else {
			return 60
		}
	} else {
		return 0
	}
}

StockcastUI private conf_symbols { } {
	global confsym

	if {![info exists confsym] || $confsym == ""} {
		return
	}
	
	set syms [split $confsym ,]
	foreach s $syms {
		set s [string trim $s]
		$self conf_symbol $s
	}	

}

StockcastUI private conf_symobl { sym } {
	$self instvar syms_ confs_
	global confval conft confd confp confv

	foreach idx [array names syms_] {
		if { "$syms_($idx)" == "$sym" } {
			switch -- $confval {
				time { set confs_($sym) [list time $conft] }
				dollar { set confs_($sym) [list dollar $confd] }
				percent { set confs_($sym) [list percent $confp] }
				vol { set confs_($sym) [list vol $confv] }
			}
		}
	}
}

StockcastUI private delrow_symbols { } {
	global delsym

	if {![info exists delsym] || $delsym == ""} {
		return
	}
	
	set syms [split $delsym ,]
	foreach s $syms {
		set s [string trim $s]
		$self delrow_symbol $s
	}

	$self change_symbols
}

StockcastUI private delrow_symbol { sym } {
	$self instvar w_ totalnumsyms_ syms_

	if {$sym == ""} {
		return
	}
	
	set can $w_.main.sl.can
	foreach idx [array names syms_] {
		if { "$syms_($idx)" == "$sym" } {	
			pack forget $can.main.f$idx
			incr totalnumsyms_ -1

			if {$totalnumsyms_ > 5} {
				set h [expr 0.5 * $totalnumsyms_]
			} else {
				set h 2.5
			}

			$can conf -scrollregion "0 0 8.1i ${h}i"
			$can yview moveto 1

			unset syms_($idx)
			return
		}
	}
}

StockcastUI private mkrow_symbols { } {
	global newsym

	if {![info exists newsym] || $newsym == ""} {
		return
	}
	
	set syms [split $newsym ,]
	foreach s $syms {
		set s [string trim $s]
		$self mkrow_symbol $s
	}

	$self change_symbols	
}

StockcastUI private mkrow_symbol { sym } {
	$self instvar w_ totalnumsyms_ numsyms_ syms_
	global data_

	if {$sym == ""} {
		return
	}

	foreach idx [array names syms_] {
		if { "$syms_($idx)" == "$sym" } {
			return
		}
	}
	
	incr numsyms_
	incr totalnumsyms_

	set syms_($numsyms_) $sym
	
	set can $w_.main.sl.can
	set l [frame $can.main.f$numsyms_]
	
	label $l.sym -text "$sym\n " -relief sunken -width 10 -anchor w
	label $l.time -textvariable data_($sym,time) -relief sunken -width 10 -anchor w
	label $l.last -textvariable data_($sym,last) -relief sunken -width 10 -anchor w
	label $l.change -textvariable data_($sym,change) -relief sunken -width 10 -anchor w
	label $l.volume -textvariable data_($sym,vol) -relief sunken -width 10 -anchor w
	label $l.trades -textvariable data_($sym,trades) -relief sunken -width 10 -anchor w
	label $l.openclose -textvariable data_($sym,openclose) -relief sunken -width 10 -anchor w
	label $l.highlow -textvariable data_($sym,highlow) -relief sunken -width 10 -anchor w

	pack $l.sym $l.time $l.last $l.change $l.volume $l.trades $l.openclose $l.highlow \
		-side left
	pack $l

	$self fillrow_symbol $sym "NA NA NA NA NA NA NA NA NA NA NA NA NA NA NA NA NA"

	if {$totalnumsyms_ > 5} {
		set h [expr 0.5 * $totalnumsyms_]
	} else {
		set h 2.5
	}

	$can conf -scrollregion "0 0 8.1i ${h}i"
	$can yview moveto 1
}

StockcastUI public fillrow_symbol { sym data } {
	global data_

	#puts "sym=$sym data=$data"

	set last [lindex $data 0]
	set changed [lindex $data 1]
	set changep [lindex $data 2]
	set vol [lindex $data 3]
	set trades [lindex $data 4]
	set low [lindex $data 7]
	set high [lindex $data 8]
	set close [lindex $data 9]							
	set open [lindex $data 10]
	set low [lindex $data 11]
	set high [lindex $data 12]
	set date [lindex $data 15]
	set time [lindex $data 16]	
	
	set data_($sym,time) "$date\n$time"
	set data_($sym,last) "$last\n "
	set data_($sym,change) "$changed\n$changep"
	set data_($sym,vol) "$vol\n "
	set data_($sym,trades) "$trades\n "
	set data_($sym,openclose) "$open\n$close"
	set data_($sym,highlow) "$high\n$low"	
}
