#
# Copyright (c) 1998 Regents of the University of California.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. All advertising materials mentioning features or use of this software
#    must display the following acknowledgement:
#       This product includes software developed by the MASH Research
#       Group at the University of California Berkeley.
# 4. Neither the name of the University nor of the Research Group may be
#    used to endorse or promote products derived from this software without
#    specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# ------------
#
#  @(#) $Header: /usr/src/mash/repository/mash/mash-1/tcl/applications/uc/application-uc.tcl,v 1.2 1999/03/03 06:44:08 hodes Exp $
#

import UniversalUI

#
# application wrapper for the a (meta-) application UniversalUI
#
Class UniversalClientApp -superclass Application


#
# constructor: args passed directly to a new UniversalUI class
#
UniversalClientApp public init {argv} {
    $self next universalclient

    set o [$self options]
    $o register_option -rendez rendez
    $o add_default rendez 224.2.127.253/1202
    $o register_option -mysrvsdir mySrvsDir
    $o add_default mySrvsDir ~/.mash/mysrvs
    set argv [$o parse_args $argv]

    if {[llength $argv] % 2 != 0} {
	$self usage
    }

    frame .f
    pack .f
    set ui_ [eval new UniversalUI .f $argv]
}

#
UniversalClientApp public usage {} {
    global argv0
    puts "Usage: $argv0 ?-rendez <addrSpec>?"
    puts "              ?<UIobjectName> <addrSpec> ...?\n"
    exit
}



